# SolmaeCode

Implementation of Solmae. Work in progress.

## Done

- [x] Working implementation of the new key gen (512 and 1024)
- [x] Implementation of signing and verification from the Mitaka(Solmae) paper
      (512 and 1024)

## To-dos (roughly in order of priority)

Crossed-out tasks are not considered for the initial submission.

1. [ ] Serialization/bit-packing of keys and signatures for KATs and
       compatibility with tools like SUPERCOP
   - [ ] **Easy:** re-use the Falcon codecs
   - [~] **Harder:** use the CRYPTO compression paper encoding techniques
2. [ ] Parameter fine-tuning
   - [ ] **Easy:** increase alpha in 1024 to aim for 256 bits of classical security
   - [ ] **Medium:** security analysis to decide which values of epsilon are
         clearly safe
   - [~] **Harder:** choose the optimal interval for keygen (possibly
         maximizing success rate at fixed entropy)
3. [~] Constant-time signing
4. [~] Support for elliptic Gaussians in the style of the CRYPTO
       compression paper
5. [~] Support for intermediate security levels (3-powersmooth cyclos)
   - [ ] **Medium:** FFT/NTT code for 3-powersmooth cyclos
   - [ ] **Hard:** better sampler à la Espitau--Wallet--Yu for 3-powersmooth
         cyclos
   - [ ] **Easy:** naive (f,g) sampling for 3-powersmooth cyclos
   - [ ] **Medium:** advanced (f,g) sampling for 3-powersmooth cyclos
   - [ ] **Hard:** `NTRUSolve` for 3-powersmooth cyclos
6. [~] Support for implementation without floating point arithmetic
       (Solmae_Z)
7. [~] Masked implementation

